---------------------------------------------------------
-- First Blood
-- Create Date: 4/26/2017
-- Version 2.0 
---------------------------------------------------------

local FBTimer, FBCounter
FBDB = FBDB or { ["Enabled"] = true, ["Counter"] = 60 }
local bit_band = bit.band
local bit_bor = bit.bor

local function hasFlag(flags, flag)
	return bit_band(flags, flag) == flag
end

---------------------------------------------------------
local OnEvent = function(self, event, ...)
	self[event](self, event, ...) -- watches mutlple event functions
end

---------------------------------------------------------
local f = CreateFrame("Frame", nil, UIParent)
f:RegisterEvent("VARIABLES_LOADED")
f:RegisterEvent("PLAYER_DEAD")
f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f:SetScript("OnEvent", OnEvent)
---------------------------------------------------------

---------------------------------------------------------

function f:PLAYER_DEAD()
	FBCounter = 0
end
		
function f:VARIABLES_LOADED()
	f:UnregisterEvent("VARIABLES_LOADED")
	DEFAULT_CHAT_FRAME:AddMessage("|cff8A0707First Blood|r Loaded")
	SLASH_FirstBlood1 = "/firstblood"
	SlashCmdList["FirstBlood"] = function(msg)
		if msg == 'toggle' then
			FBDB.Enabled = not FBDB.Enabled
			DEFAULT_CHAT_FRAME:AddMessage("|cff8A0707First Blood|r: Enabled = "..tostring(FBDB.Enabled))
		elseif msg == '10' then
			FBDB.Counter = 10
			DEFAULT_CHAT_FRAME:AddMessage("|cff8A0707First Blood|r: Set to 10 Seconds")
			do return end
		elseif msg == '20' then
			FBDB.Counter = 20
			DEFAULT_CHAT_FRAME:AddMessage("|cff8A0707First Blood|r: Set to 20 Seconds")
			do return end
		elseif msg == '30' then
			FBDB.Counter = 30
			DEFAULT_CHAT_FRAME:AddMessage("|cff8A0707First Blood|r: Set to 30 Seconds")
			do return end
		elseif msg == '40' then
			FBDB.Counter = 40
			DEFAULT_CHAT_FRAME:AddMessage("|cff8A0707First Blood|r: Set to 40 Seconds")
			do return end
		elseif msg == '50' then
			FBDB.Counter = 50	
			DEFAULT_CHAT_FRAME:AddMessage("|cff8A0707First Blood|r: Set to 50 Seconds")
			do return end
		elseif msg == '60' then
			FBDB.Counter = 60
			DEFAULT_CHAT_FRAME:AddMessage("|cff8A0707First Blood|r: Set to 60 Seconds")
			do return end
		else
		DEFAULT_CHAT_FRAME:AddMessage("|cff8A0707First Blood|r: /firstblood toggle - to Enable or Disable")
		DEFAULT_CHAT_FRAME:AddMessage("|cff8A0707First Blood|r: /firstblood 10-60  - (in 10 second Increments) to change the time needed between kills")
		end
	end
end

function f:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, auraType, ...)
	if (eventType == "PARTY_KILL") and hasFlag(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) and hasFlag(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) and FBDB.Enabled then
			if (not FBTimer or (GetTime() - FBTimer > FBDB.Counter)) then
				PlaySoundFile("Interface\\AddOns\\FirstBlood\\Sounds\\firstblood.mp3")
				FBCounter = 1
			elseif (GetTime() - FBTimer <= FBDB.Counter) then
				FBCounter = FBCounter + 1
				if (FBCounter == 2) then
					PlaySoundFile("Interface\\AddOns\\FirstBlood\\Sounds\\dominating.mp3")
				elseif (FBCounter == 3) then
					PlaySoundFile("Interface\\AddOns\\FirstBlood\\Sounds\\killingspree.mp3")
				elseif (FBCounter == 4) then
					PlaySoundFile("Interface\\AddOns\\FirstBlood\\Sounds\\unstoppable.mp3")
				elseif (FBCounter > 5) then
					PlaySoundFile("Interface\\AddOns\\FirstBlood\\Sounds\\godlike.mp3")
				end
			end
		FBTimer = GetTime()
	end
end